org.eclipse.rdf4j.query.algebra.evaluation.impl

## Class QueryJoinOptimizer

- java.lang.Object
- - org.eclipse.rdf4j.query.algebra.evaluation.impl.QueryJoinOptimizer

- All Implemented Interfaces:
    QueryOptimizer

      public class QueryJoinOptimizer
      extends Object
      implements QueryOptimizer

  A query optimizer that re-orders nested Joins.
  Author:
    Arjohn Kampman, James Leigh

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `QueryJoinOptimizer.JoinVisitor` Deprecated. This class is protected for historic reasons only, and will be made private in a future major release.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected EvaluationStatistics` | `statistics`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `QueryJoinOptimizer()`
    `QueryJoinOptimizer(EvaluationStatistics statistics)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `optimize(TupleExpr tupleExpr, Dataset dataset, BindingSet bindings)` Applies generally applicable optimizations: path expressions are sorted from more to less specific.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### statistics

          protected final EvaluationStatistics statistics

  - ### Constructor Detail

    - #### QueryJoinOptimizer

          public QueryJoinOptimizer()

    - #### QueryJoinOptimizer

          public QueryJoinOptimizer(EvaluationStatistics statistics)

  - ### Method Detail

    - #### optimize

          public void optimize(TupleExpr tupleExpr,
                               Dataset dataset,
                               BindingSet bindings)

      Applies generally applicable optimizations: path expressions are sorted from more to less specific.
      Specified by:
        `optimize` in interface `QueryOptimizer`
      Parameters:
        `tupleExpr` -

Copyright © 2015-2020 Eclipse Foundation. All Rights Reserved.